var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var DICTIONARY = 'ABCDEFGHJKLMNOPQRSTUVWXYZabcdefhijkmnopqrstuvwxyz23456789';
var DICTIONARY_LENGTH = BigInt(DICTIONARY.length);
var SHARECODE_PATTERN = /^CSGO(-?[\w]{5}){5}$/;
var InvalidShareCode = (function (_super) {
    __extends(InvalidShareCode, _super);
    function InvalidShareCode() {
        return _super.call(this, 'Invalid share code') || this;
    }
    return InvalidShareCode;
}(Error));
export { InvalidShareCode };
var InvalidCrosshairShareCode = (function (_super) {
    __extends(InvalidCrosshairShareCode, _super);
    function InvalidCrosshairShareCode() {
        return _super.call(this, 'Invalid crosshair share code') || this;
    }
    return InvalidCrosshairShareCode;
}(Error));
export { InvalidCrosshairShareCode };
function bytesToHex(bytes) {
    return Array.from(bytes, function (byte) {
        return ('0' + (byte & 0xff).toString(16)).slice(-2);
    }).join('');
}
function bytesToBigInt(bytes) {
    var hex = bytesToHex(bytes);
    return BigInt("0x".concat(hex));
}
function stringToBytes(str) {
    var bytes = [];
    for (var i = 0; i < str.length; i += 2) {
        bytes.push(parseInt(str.slice(i, i + 2), 16));
    }
    return bytes;
}
function int16ToBytes(number) {
    return [(number & 0x0000ff00) >> 8, number & 0x000000ff];
}
function uint8ToInt8(number) {
    return (number << 24) >> 24;
}
function sumArray(array) {
    return array.reduce(function (previousValue, value) {
        return previousValue + value;
    }, 0);
}
function shareCodeToBytes(shareCode) {
    if (!shareCode.match(SHARECODE_PATTERN)) {
        throw new InvalidShareCode();
    }
    shareCode = shareCode.replace(/CSGO|-/g, '');
    var chars = Array.from(shareCode).reverse();
    var big = BigInt(0);
    for (var i = 0; i < chars.length; i++) {
        big = big * DICTIONARY_LENGTH + BigInt(DICTIONARY.indexOf(chars[i]));
    }
    var str = big.toString(16).padStart(36, '0');
    var bytes = stringToBytes(str);
    return bytes;
}
function bytesToShareCode(bytes) {
    var hex = bytesToHex(bytes);
    var total = BigInt("0x".concat(hex));
    var chars = '';
    var rem = BigInt(0);
    for (var i = 0; i < 25; i++) {
        rem = total % DICTIONARY_LENGTH;
        chars += DICTIONARY[Number(rem)];
        total = total / DICTIONARY_LENGTH;
    }
    return "CSGO-".concat(chars.slice(0, 5), "-").concat(chars.slice(5, 10), "-").concat(chars.slice(10, 15), "-").concat(chars.slice(15, 20), "-").concat(chars.slice(20, 25));
}
export function encodeMatch(_a) {
    var matchId = _a.matchId, reservationId = _a.reservationId, tvPort = _a.tvPort;
    var matchBytes = stringToBytes(matchId.toString(16)).reverse();
    var reservationBytes = stringToBytes(reservationId.toString(16)).reverse();
    var tvBytes = int16ToBytes(tvPort).reverse();
    var bytes = __spreadArray(__spreadArray(__spreadArray([], matchBytes, true), reservationBytes, true), tvBytes, true);
    var shareCode = bytesToShareCode(bytes);
    return shareCode;
}
export function decodeMatchShareCode(shareCode) {
    var bytes = shareCodeToBytes(shareCode);
    return {
        matchId: bytesToBigInt(bytes.slice(0, 8).reverse()),
        reservationId: bytesToBigInt(bytes.slice(8, 16).reverse()),
        tvPort: Number(bytesToBigInt(bytes.slice(16, 18).reverse()))
    };
}
export function decodeCrosshairShareCode(shareCode) {
    var bytes = shareCodeToBytes(shareCode);
    var size = sumArray(bytes.slice(1)) % 256;
    if (bytes[0] !== size) {
        throw new InvalidCrosshairShareCode();
    }
    var crosshair = {
        gap: uint8ToInt8(bytes[2]) / 10,
        outline: bytes[3] / 2,
        red: bytes[4],
        green: bytes[5],
        blue: bytes[6],
        alpha: bytes[7],
        splitDistance: bytes[8],
        fixedCrosshairGap: uint8ToInt8(bytes[9]) / 10,
        color: bytes[10] & 7,
        outlineEnabled: (bytes[10] & 8) === 8,
        innerSplitAlpha: (bytes[10] >> 4) / 10,
        outerSplitAlpha: (bytes[11] & 0xf) / 10,
        splitSizeRatio: (bytes[11] >> 4) / 10,
        thickness: bytes[12] / 10,
        centerDotEnabled: ((bytes[13] >> 4) & 1) === 1,
        deployedWeaponGapEnabled: ((bytes[13] >> 4) & 2) === 2,
        alphaEnabled: ((bytes[13] >> 4) & 4) === 4,
        tStyleEnabled: ((bytes[13] >> 4) & 8) === 8,
        style: (bytes[13] & 0xf) >> 1,
        length: bytes[14] / 10
    };
    return crosshair;
}
export function encodeCrosshair(crosshair) {
    var bytes = [
        0,
        1,
        (crosshair.gap * 10) & 0xff,
        crosshair.outline * 2,
        crosshair.red,
        crosshair.green,
        crosshair.blue,
        crosshair.alpha,
        crosshair.splitDistance,
        (crosshair.fixedCrosshairGap * 10) & 0xff,
        (crosshair.color & 7) | (Number(crosshair.outlineEnabled) << 3) | ((crosshair.innerSplitAlpha * 10) << 4),
        (crosshair.outerSplitAlpha * 10) | ((crosshair.splitSizeRatio * 10) << 4),
        crosshair.thickness * 10,
        (crosshair.style << 1) |
            (Number(crosshair.centerDotEnabled) << 4) |
            (Number(crosshair.deployedWeaponGapEnabled) << 5) |
            (Number(crosshair.alphaEnabled) << 6) |
            (Number(crosshair.tStyleEnabled) << 7),
        crosshair.length * 10,
        0,
        0,
        0,
    ];
    bytes[0] = sumArray(bytes) & 0xff;
    var shareCode = bytesToShareCode(bytes);
    return shareCode;
}
export function crosshairToConVars(crosshair) {
    return "\ncl_crosshair_drawoutline \"".concat(Number(crosshair.outlineEnabled), "\"\ncl_crosshair_dynamic_maxdist_splitratio \"").concat(crosshair.splitSizeRatio, "\"\ncl_crosshair_dynamic_splitalpha_innermod \"").concat(crosshair.innerSplitAlpha, "\"\ncl_crosshair_dynamic_splitalpha_outermod \"").concat(crosshair.outerSplitAlpha, "\"\ncl_crosshair_dynamic_splitdist \"").concat(crosshair.splitDistance, "\"\ncl_crosshair_outlinethickness \"").concat(crosshair.outline, "\"\ncl_crosshair_t \"").concat(Number(crosshair.tStyleEnabled), "\"\ncl_crosshairalpha \"").concat(crosshair.alpha, "\"\ncl_crosshaircolor \"").concat(crosshair.color, "\"\ncl_crosshaircolor_b \"").concat(crosshair.blue, "\"\ncl_crosshaircolor_g \"").concat(crosshair.green, "\"\ncl_crosshaircolor_r \"").concat(crosshair.red, "\"\ncl_crosshairdot \"").concat(Number(crosshair.centerDotEnabled), "\"\ncl_crosshairgap \"").concat(crosshair.gap, "\"\ncl_crosshairgap_useweaponvalue \"").concat(Number(crosshair.deployedWeaponGapEnabled), "\"\ncl_crosshairsize \"").concat(crosshair.length, "\"\ncl_crosshairstyle \"").concat(crosshair.style, "\"\ncl_crosshairthickness \"").concat(crosshair.thickness, "\"\ncl_crosshairusealpha \"").concat(Number(crosshair.alphaEnabled), "\"\ncl_fixedcrosshairgap \"").concat(crosshair.fixedCrosshairGap, "\"\n");
}
//# sourceMappingURL=index.js.map